Skip to content
geeksforgeeks
  • Courses
    • DSA to Development
    • Get IBM Certification
    • Newly Launched!
      • Master Django Framework
      • Become AWS Certified
    • For Working Professionals
      • Interview 101: DSA & System Design
      • Data Science Training Program
      • JAVA Backend Development (Live)
      • DevOps Engineering (LIVE)
      • Data Structures & Algorithms in Python
    • For Students
      • Placement Preparation Course
      • Data Science (Live)
      • Data Structure & Algorithm-Self Paced (C++/JAVA)
      • Master Competitive Programming (Live)
      • Full Stack Development with React & Node JS (Live)
    • Full Stack Development
    • Data Science Program
    • All Courses
  • Tutorials
    • Data Structures & Algorithms
    • ML & Data Science
    • Interview Corner
    • Programming Languages
    • Web Development
    • CS Subjects
    • DevOps And Linux
    • School Learning
  • Practice
    • Build your AI Agent
    • GfG 160
    • Problem of the Day
    • Practice Coding Problems
    • GfG SDE Sheet
  • Contests
    • Accenture Hackathon (Ending Soon!)
    • GfG Weekly [Rated Contest]
    • Job-A-Thon Hiring Challenge
    • All Contests and Events
  • DSA
  • Interview Questions on Array
  • Practice Array
  • MCQs on Array
  • Tutorial on Array
  • Types of Arrays
  • Array Operations
  • Subarrays, Subsequences, Subsets
  • Reverse Array
  • Static Vs Arrays
  • Array Vs Linked List
  • Array | Range Queries
  • Advantages & Disadvantages
Open In App
Next Article:
Count pairs from a given range having equal Bitwise OR and XOR values
Next article icon

Count pairs having bitwise XOR greater than K from a given array

Last Updated : 22 Mar, 2023
Comments
Improve
Suggest changes
Like Article
Like
Report

Given an array arr[]of size N and an integer K, the task is to count the number of pairs from the given array such that the Bitwise XOR of each pair is greater than K. 

 Examples:

Input: arr = {1, 2, 3, 5} , K = 2 
Output: 4 
Explanation: 
Bitwise XOR of all possible pairs that satisfy the given conditions are: 
arr[0] ^ arr[1] = 1 ^ 2 = 3 
arr[0] ^ arr[3] = 1 ^ 5 = 4 
arr[1] ^ arr[3] = 2 ^ 5 = 7 
arr[0] ^ arr[3] = 3 ^ 5 = 6 
Therefore, the required output is 4. 

Input: arr[] = {3, 5, 6,8}, K = 2 
Output: 6 
 

Naive Approach: The simplest approach to solve this problem is to traverse the given array and generate all possible pairs of the given array and for each pair, check if bitwise XOR of the pair is greater than K or not. If found to be true, then increment the count of pairs having bitwise XOR greater than K. Finally, print the count of such pairs obtained.

C++
// C++ program to implement // the above approach  #include <bits/stdc++.h> using namespace std;  // Function to Count pairs having  // bitwise XOR greater than K  // from a given array int cntGreaterPairs(int arr[], int n, int k) {     // Variable initialise to store the count     int count=0;          // Traverse in the array and     // generate all possible pairs      // of the given array      for(int i=0;i<n;i++)     {         for(int j=i+1;j<n;j++)         {             // For every pair, check if bitwise              // XOR of the pair is greater than              // K or not             if(arr[i]^arr[j]>k)             count++;         }     }          // return the count     return count; }  //Driver code int main() {     int arr[] = {3, 5, 6, 8};     int K= 2;     int N = sizeof(arr) / sizeof(arr[0]);          cout<<cntGreaterPairs(arr, N, K); }  // This code is contributed by Utkarsh Kumar. 
Java
// Java program to implement // the above approach  import java.util.*;  class Main {      // Function to Count pairs having     // bitwise XOR greater than K     // from a given array     static int cntGreaterPairs(int arr[], int n, int k)     {         // Variable initialise to store the count         int count = 0;          // Traverse in the array and         // generate all possible pairs         // of the given array         for (int i = 0; i < n; i++) {             for (int j = i + 1; j < n; j++) {                 // For every pair, check if bitwise                 // XOR of the pair is greater than                 // K or not                 if ((arr[i] ^ arr[j]) > k)                     count++;             }         }          // return the count         return count;     }      // Driver code     public static void main(String args[])     {         int arr[] = { 3, 5, 6, 8 };         int K = 2;         int N = arr.length;          System.out.print(cntGreaterPairs(arr, N, K));     } } 
Python3
# Function to count pairs having bitwise XOR greater than K from a given array def cntGreaterPairs(arr, n, k):        # Variable initialise to store the count     count = 0          # Traverse in the array and     # generate all possible pairs      # of the given array      for i in range(n):         for j in range(i+1, n):                        # For every pair, check if bitwise              # XOR of the pair is greater than              # K or not             if arr[i]^arr[j] > k:                 count += 1          # Return the count     return count  # Driver code arr = [3, 5, 6, 8] K = 2 N = len(arr)  print(cntGreaterPairs(arr, N, K)) 
JavaScript
// Function to count pairs having bitwise XOR greater than K from a given array function cntGreaterPairs(arr, n, k) { // Variable initialise to store the count let count = 0;  // Traverse in the array and // generate all possible pairs  // of the given array  for (let i = 0; i < n; i++) {     for (let j = i+1; j < n; j++) {                // For every pair, check if bitwise          // XOR of the pair is greater than          // K or not         if ((arr[i]^arr[j]) > k) {             count++;         }     } }  // Return the count return count; }  // Driver code const arr = [3, 5, 6, 8]; const K = 2; const N = arr.length;  console.log(cntGreaterPairs(arr, N, K)); 
C#
using System;  public class Program {     // Function to Count pairs having      // bitwise XOR greater than K      // from a given array     public static int cntGreaterPairs(int[] arr, int n, int k)     {         // Variable initialise to store the count         int count = 0;          // Traverse in the array and         // generate all possible pairs          // of the given array          for (int i = 0; i < n; i++)         {             for (int j = i + 1; j < n; j++)             {                 // For every pair, check if bitwise                  // XOR of the pair is greater than                  // K or not                 if ((arr[i] ^ arr[j]) > k)                     count++;             }         }          // return the count         return count;     }      //Driver code     public static void Main()     {         int[] arr = { 3, 5, 6, 8 };         int K = 2;         int N = arr.Length;          Console.WriteLine(cntGreaterPairs(arr, N, K));     } } 

Output
6

Time Complexity:O(N2)
Auxiliary Space:O(1)

Efficient Approach: The problem can be solved using Trie. The idea is to iterate over the given array and for each array element, count the number of elements present in the Trie whose bitwise XOR with the current element is greater than K and insert the binary representation of the current element into the Trie. Finally, print the count of pairs having bitwise XOR greater than K. Follow the steps below to solve the problem:

  • Create a Trie having root node, say root to store the binary representation of each element of the given array.
  • Traverse the given array, and count the number of elements present in the Trie whose bitwise XOR with the current element is greater than K and insert the binary representation of the current element.
  • Finally, print the count of pairs that satisfies the given condition.

Below is the implementation of the above approach:

C++
// C++ program to implement // the above approach  #include <bits/stdc++.h> using namespace std;  // Structure of Trie struct TrieNode {     // Stores binary representation     // of numbers     TrieNode *child[2];      // Stores count of elements     // present in a node       int cnt;          // Function to initialize     // a Trie Node     TrieNode() {         child[0] = child[1] = NULL;         cnt = 0;     } };   // Function to insert a number into Trie void insertTrie(TrieNode *root, int N) {          // Traverse binary representation of X.     for (int i = 31; i >= 0; i--) {                  // Stores ith bit of N         bool x = (N) & (1 << i);                  // Check if an element already         // present in Trie having ith bit x.         if(!root->child[x]) {                          // Create a new node of Trie.             root->child[x] = new TrieNode();         }                  // Update count of elements         // whose ith bit is x         root->child[x]->cnt+= 1;                  // Update root.         root= root->child[x];      } }   // Function to count elements // in Trie whose XOR with N // exceeds K int cntGreater(TrieNode * root,                  int N, int K) {          // Stores count of elements     // whose XOR with N exceeding K     int cntPairs = 0;          // Traverse binary representation     // of N and K in Trie     for (int i = 31; i >= 0 &&                       root; i--) {                                             // Stores ith bit of N                                  bool x = N & (1 << i);                  // Stores ith bit of K         bool y = K & (1 << i);                  // If the ith bit of K is 1         if (y) {                          // Update root.             root =                  root->child[1 - x];         }                  // If the ith bit of K is 0         else{                          // If an element already              // present in Trie having             // ith bit (1 - x)             if (root->child[1 - x]) {                                  // Update cntPairs                 cntPairs +=                  root->child[1 - x]->cnt;             }                          // Update root.             root = root->child[x];         }     }     return cntPairs; }  // Function to count pairs that  // satisfy the given conditions. int cntGreaterPairs(int arr[], int N,                              int K) {          // Create root node of Trie     TrieNode *root = new TrieNode();          // Stores count of pairs that     // satisfy the given conditions     int cntPairs = 0;          // Traverse the given array.     for(int i = 0;i < N; i++){                  // Update cntPairs         cntPairs += cntGreater(root,                             arr[i], K);                  // Insert arr[i] into Trie.         insertTrie(root, arr[i]);     }     return cntPairs; }  //Driver code int main() {     int arr[] = {3, 5, 6, 8};     int K= 2;     int N = sizeof(arr) / sizeof(arr[0]);          cout<<cntGreaterPairs(arr, N, K); } 
Java
// Java program to implement // the above approach import java.util.*; class GFG{  // Structure of Trie static class TrieNode {   // Stores binary representation   // of numbers   TrieNode []child = new TrieNode[2];    // Stores count of elements   // present in a node     int cnt;    // Function to initialize   // a Trie Node   TrieNode()    {     child[0] = child[1] = null;     cnt = 0;   }  };  // Function to insert a number // into Trie static void insertTrie(TrieNode root,                         int N)  {   // Traverse binary representation    // of X.   for (int i = 31; i >= 0; i--)    {     // Stores ith bit of N     int x = (N) & (1 << i);      // Check if an element already     // present in Trie having ith      // bit x.     if (x < 2 && root.child[x] == null)      {       // Create a new node of Trie.       root.child[x] = new TrieNode();     }      // Update count of elements     // whose ith bit is x     if(x < 2 && root.child[x] != null)       root.child[x].cnt += 1;      // Update root.     if(x < 2)       root = root.child[x];   } }  // Function to count elements // in Trie whose XOR with N // exceeds K static int cntGreater(TrieNode root,                        int N, int K)  {   // Stores count of elements   // whose XOR with N exceeding K   int cntPairs = 1;    // Traverse binary representation   // of N and K in Trie   for (int i = 31; i >= 0 &&             root!=null; i--)    {     // Stores ith bit of N     int x = N & (1 << i);      // Stores ith bit of K     int y = K & (1 << i);      // If the ith bit of K is 1     if (y == 1)      {       // Update root.       root = root.child[1 - x];     }      // If the ith bit of K is 0     else     {       // If an element already       // present in Trie having       // ith bit (1 - x)       if (x < 2 &&            root.child[1 - x] != null)        {         // Update cntPairs         cntPairs += root.child[1 - x].cnt;       }        // Update root.       if(x < 2)         root = root.child[x];     }   }   return cntPairs; }  // Function to count pairs that // satisfy the given conditions. static int cntGreaterPairs(int arr[],                             int N, int K)  {   // Create root node of Trie   TrieNode root = new TrieNode();    // Stores count of pairs that   // satisfy the given conditions   int cntPairs = 0;    // Traverse the given array.   for (int i = 0; i < N; i++)    {     // Update cntPairs     cntPairs += cntGreater(root,                            arr[i], K);      // Insert arr[i] into Trie.     insertTrie(root, arr[i]);   }   return cntPairs; }  // Driver code public static void main(String[] args)  {   int arr[] = {3, 5, 6, 8};   int K = 2;   int N = arr.length;   System.out.print(cntGreaterPairs(arr,                                     N, K)); } }  // This code is contributed by shikhasingrajput 
Python3
# Python3 program to implement # the above approach   # Structure of Trie class TrieNode:      # Function to initialize     # a Trie Node     def __init__(self):                  self.child = [None, None]         self.cnt = 0  # Function to insert a number into Trie def insertTrie(root, N):          # Traverse binary representation of X.     for i in range(31, -1, -1):                  # Stores ith bit of N         x = bool((N) & (1 << i))                   # Check if an element already         # present in Trie having ith bit x.         if (root.child[x] == None):                           # Create a new node of Trie.             root.child[x] = TrieNode()                      # Update count of elements         # whose ith bit is x         root.child[x].cnt += 1                   # Update root         root= root.child[x]    # Function to count elements # in Trie whose XOR with N # exceeds K def cntGreater(root, N, K):           # Stores count of elements     # whose XOR with N exceeding K     cntPairs = 0           # Traverse binary representation     # of N and K in Trie     for i in range(31, -1, -1):         if (root == None):             break                                              # Stores ith bit of N                                  x = bool(N & (1 << i))                   # Stores ith bit of K         y = K & (1 << i)                   # If the ith bit of K is 1         if (y != 0):                           # Update root             root = root.child[1 - x]                   # If the ith bit of K is 0         else:                          # If an element already              # present in Trie having             # ith bit (1 - x)             if (root.child[1 - x]):                                   # Update cntPairs                 cntPairs += root.child[1 - x].cnt                           # Update root             root = root.child[x]      return cntPairs  # Function to count pairs that  # satisfy the given conditions. def cntGreaterPairs(arr, N, K):           # Create root node of Trie     root = TrieNode()           # Stores count of pairs that     # satisfy the given conditions     cntPairs = 0           # Traverse the given array.     for i in range(N):                   # Update cntPairs         cntPairs += cntGreater(root, arr[i], K)                   # Insert arr[i] into Trie.         insertTrie(root, arr[i])          return cntPairs  # Driver code if __name__=='__main__':          arr = [ 3, 5, 6, 8 ]     K = 2     N = len(arr)           print(cntGreaterPairs(arr, N, K))      # This code is contributed by rutvik_56 
C#
// C# program to implement // the above approach using System;  class GFG{  // Structure of Trie public class TrieNode {    // Stores binary representation   // of numbers   public TrieNode []child = new TrieNode[2];      // Stores count of elements   // present in a node     public int cnt;      // Function to initialize   // a Trie Node   public TrieNode()    {     child[0] = child[1] = null;     cnt = 0;   } };  // Function to insert a number // into Trie static void insertTrie(TrieNode root,                         int N)  {      // Traverse binary representation    // of X.   for(int i = 31; i >= 0; i--)    {          // Stores ith bit of N     int x = (N) & (1 << i);      // Check if an element already     // present in Trie having ith      // bit x.     if (x < 2 && root.child[x] == null)      {              // Create a new node of Trie.       root.child[x] = new TrieNode();     }      // Update count of elements     // whose ith bit is x     if(x < 2 && root.child[x] != null)       root.child[x].cnt += 1;      // Update root.     if(x < 2)       root = root.child[x];   } }  // Function to count elements // in Trie whose XOR with N // exceeds K static int cntGreater(TrieNode root,                        int N, int K)  {      // Stores count of elements   // whose XOR with N exceeding K   int cntPairs = 1;    // Traverse binary representation   // of N and K in Trie   for(int i = 31; i >= 0 &&        root != null; i--)    {          // Stores ith bit of N     int x = N & (1 << i);      // Stores ith bit of K     int y = K & (1 << i);      // If the ith bit of K is 1     if (y == 1)      {              // Update root.       root = root.child[1 - x];     }      // If the ith bit of K is 0     else     {              // If an element already       // present in Trie having       // ith bit (1 - x)       if (x < 2 &&            root.child[1 - x] != null)        {                  // Update cntPairs         cntPairs += root.child[1 - x].cnt;       }        // Update root.       if(x < 2)         root = root.child[x];     }   }   return cntPairs; }  // Function to count pairs that // satisfy the given conditions. static int cntGreaterPairs(int []arr,                             int N, int K)  {      // Create root node of Trie   TrieNode root = new TrieNode();    // Stores count of pairs that   // satisfy the given conditions   int cntPairs = 0;    // Traverse the given array.   for(int i = 0; i < N; i++)    {          // Update cntPairs     cntPairs += cntGreater(root,                            arr[i], K);      // Insert arr[i] into Trie.     insertTrie(root, arr[i]);   }   return cntPairs; }  // Driver code public static void Main(String[] args)  {   int []arr = { 3, 5, 6, 8 };   int K = 2;   int N = arr.Length;      Console.Write(cntGreaterPairs(arr,                                  N, K)); } }  // This code is contributed by gauravrajput1  
JavaScript
<script> // Javascript program to implement // the above approach  // Structure of Trie class TrieNode {     constructor()     {         this.child = new Array(2);         this.child[0] = this.child[1] = null;         this.cnt = 0;     } }  // Function to insert a number // into Trie function insertTrie(root,N) {      // Traverse binary representation   // of X.   for (let i = 31; i >= 0; i--)   {        // Stores ith bit of N     let x = (N) & (1 << i);       // Check if an element already     // present in Trie having ith     // bit x.     if (x < 2 && root.child[x] == null)     {       // Create a new node of Trie.       root.child[x] = new TrieNode();     }       // Update count of elements     // whose ith bit is x     if(x < 2 && root.child[x] != null)       root.child[x].cnt += 1;       // Update root.     if(x < 2)       root = root.child[x];   } }  // Function to count elements // in Trie whose XOR with N // exceeds K function  cntGreater(root, N, K) {      // Stores count of elements   // whose XOR with N exceeding K   let cntPairs = 1;     // Traverse binary representation   // of N and K in Trie   for (let i = 31; i >= 0 &&            root!=null; i--)   {     // Stores ith bit of N     let x = N & (1 << i);       // Stores ith bit of K     let y = K & (1 << i);       // If the ith bit of K is 1     if (y == 1)     {            // Update root.       root = root.child[1 - x];     }       // If the ith bit of K is 0     else     {            // If an element already       // present in Trie having       // ith bit (1 - x)       if (x < 2 &&           root.child[1 - x] != null)       {         // Update cntPairs         cntPairs += root.child[1 - x].cnt;       }         // Update root.       if(x < 2)         root = root.child[x];     }   }   return cntPairs; }  // Function to count pairs that // satisfy the given conditions. function cntGreaterPairs(arr,N,K) {     // Create root node of Trie   let root = new TrieNode();     // Stores count of pairs that   // satisfy the given conditions   let cntPairs = 0;     // Traverse the given array.   for (let i = 0; i < N; i++)   {     // Update cntPairs     cntPairs += cntGreater(root,                            arr[i], K);       // Insert arr[i] into Trie.     insertTrie(root, arr[i]);   }   return cntPairs; }  // Driver code let arr=[3, 5, 6, 8]; let K = 2; let N = arr.length; document.write(cntGreaterPairs(arr,N, K));       // This code is contributed by patel2127 </script> 

Output
6

Time Complexity:O(N * 32)
Auxiliary Space:O(N * 32)


Next Article
Count pairs from a given range having equal Bitwise OR and XOR values
author
sk9209767
Improve
Article Tags :
  • Misc
  • Bit Magic
  • Searching
  • Mathematical
  • Advanced Data Structure
  • DSA
  • Arrays
  • Trie
  • Bitwise-XOR
Practice Tags :
  • Advanced Data Structure
  • Arrays
  • Bit Magic
  • Mathematical
  • Misc
  • Searching
  • Trie

Similar Reads

  • Count pairs having Bitwise XOR less than K from given array
    Given an array arr[]of size N and an integer K, the task is to count the number of pairs from the given array such that the Bitwise XOR of each pair is less than K. Examples: Input: arr = {1, 2, 3, 5} , K = 5 Output: 4 Explanation: Bitwise XOR of all possible pairs that satisfy the given conditions
    15+ min read
  • Count pairs from an array whose Bitwise OR is greater than Bitwise AND
    Given an array A[] consisting of N integers, the task is to count the number of pairs (i, j) such that i < j, and Bitwise OR of A[i] and A[j] is greater than Bitwise AND of A[i] and A[j]. Examples: Input: A[] = {1, 4, 7}Output: 3Explanation: There are 3 such pairs: (1, 4), (4, 7), (1, 7).1) 1 | 4
    10 min read
  • Count pairs from a given range having equal Bitwise OR and XOR values
    Given an integer N, the task is to find the count total number of pairs (P, Q) from the range 0 ≤ P, Q < 2N, such that P OR Q = P XOR Q. Since the count can be very large, print it to modulo 109 + 7. Examples: Input: N = 1Output: 3Explanation: The pairs (P, Q) satisfying P OR Q = P XOR Q are (0,
    11 min read
  • Check if any Array pair has bitwise XOR greater than bitwise AND
    Given an array arr[] of size N, the task is to find if there exists a pair in the array, such that their bitwise XOR is greater than their bitwise AND i.e. arr[i] ⊕ arr[j] > arr[i] & arr[j], (0 ≤ i < j ≤ N-1) where ⊕ represents the Bitwise XOR operator and & represents bitwise AND oper
    9 min read
  • Count pairs from given array with Bitwise OR equal to K
    Given an array arr[] consisting of N positive integers and an integer K, the task is to count all pairs possible from the given array with Bitwise OR equal to K. Examples: Input: arr[] = {2, 38, 44, 29, 62}, K = 46Output: 2Explanation: Only the following two pairs are present in the array whose Bitw
    5 min read
  • Count all triplets from given Array whose bitwise XOR is equal to K
    Given an array arr[] which contains N positive integers and an integer K. The task is to count all triplets whose XOR is equal to the K. i.e arr[ i ] ^ arr[ j ] ^ arr[ k ] = X where 0 ≤ i < j < k < N ( 0 based indexing) Examples: Input: arr[] = { 2, 1, 3, 7, 5, 4}, K = 5Output: 2Explanation
    15+ min read
  • Count pairs with bitwise XOR exceeding bitwise AND from a given array
    Given an array, arr[] of size N, the task is to count the number of pairs from the given array such that the bitwise AND(&) of each pair is less than its bitwise XOR(^). Examples: Input: arr[] = {1, 2, 3, 4, 5} Output: 8Explanation: Pairs that satisfy the given conditions are: (1 & 2) < (
    10 min read
  • Count subsequences having odd Bitwise XOR values from an array
    Given an array A[] of size N, the task is to count the number of subsequences from the given array whose Bitwise XOR value is odd. Examples: Input: A[] = {1, 3, 4}Output: 4Explanation: Subsequences with odd Bitwise XOR are {1}, {3}, {1, 4}, {3, 4}. Input: A[] = {2, 8, 6}Output: 0Explanation: No such
    5 min read
  • Bitwise XOR of Bitwise AND of all pairs from two given arrays
    Given two arrays arr1[] and arr2[] consisting of N and M integers respectively, the task is to print the Bitwise XOR of Bitwise AND of all pairs possible by selecting an element from arr1[] and arr2[]. Examples: Input: arr1[] = {1, 2, 3}, arr2[] = {6, 5}Output: 0Explanation: Bitwise AND of the pair
    10 min read
  • Count pair of nodes with greater Bitwise AND than Bitwise XOR in given Linked List
    Given a singly linked list, the task is to Count the pairs of nodes with greater Bitwise AND than Bitwise XOR. Examples: Input: list: 1->4->2->6->3Output: 2Explanation: 1st List Node Pair: (4, 6 ), Bitwise AND = 4, Bitwise XOR = 22nd List Node Pair: (2, 3), Bitwise AND = 2, Bitwise XOR =
    13 min read
geeksforgeeks-footer-logo
Corporate & Communications Address:
A-143, 7th Floor, Sovereign Corporate Tower, Sector- 136, Noida, Uttar Pradesh (201305)
Registered Address:
K 061, Tower K, Gulshan Vivante Apartment, Sector 137, Noida, Gautam Buddh Nagar, Uttar Pradesh, 201305
GFG App on Play Store GFG App on App Store
Advertise with us
  • Company
  • About Us
  • Legal
  • Privacy Policy
  • In Media
  • Contact Us
  • Advertise with us
  • GFG Corporate Solution
  • Placement Training Program
  • Languages
  • Python
  • Java
  • C++
  • PHP
  • GoLang
  • SQL
  • R Language
  • Android Tutorial
  • Tutorials Archive
  • DSA
  • Data Structures
  • Algorithms
  • DSA for Beginners
  • Basic DSA Problems
  • DSA Roadmap
  • Top 100 DSA Interview Problems
  • DSA Roadmap by Sandeep Jain
  • All Cheat Sheets
  • Data Science & ML
  • Data Science With Python
  • Data Science For Beginner
  • Machine Learning
  • ML Maths
  • Data Visualisation
  • Pandas
  • NumPy
  • NLP
  • Deep Learning
  • Web Technologies
  • HTML
  • CSS
  • JavaScript
  • TypeScript
  • ReactJS
  • NextJS
  • Bootstrap
  • Web Design
  • Python Tutorial
  • Python Programming Examples
  • Python Projects
  • Python Tkinter
  • Python Web Scraping
  • OpenCV Tutorial
  • Python Interview Question
  • Django
  • Computer Science
  • Operating Systems
  • Computer Network
  • Database Management System
  • Software Engineering
  • Digital Logic Design
  • Engineering Maths
  • Software Development
  • Software Testing
  • DevOps
  • Git
  • Linux
  • AWS
  • Docker
  • Kubernetes
  • Azure
  • GCP
  • DevOps Roadmap
  • System Design
  • High Level Design
  • Low Level Design
  • UML Diagrams
  • Interview Guide
  • Design Patterns
  • OOAD
  • System Design Bootcamp
  • Interview Questions
  • Inteview Preparation
  • Competitive Programming
  • Top DS or Algo for CP
  • Company-Wise Recruitment Process
  • Company-Wise Preparation
  • Aptitude Preparation
  • Puzzles
  • School Subjects
  • Mathematics
  • Physics
  • Chemistry
  • Biology
  • Social Science
  • English Grammar
  • Commerce
  • World GK
  • GeeksforGeeks Videos
  • DSA
  • Python
  • Java
  • C++
  • Web Development
  • Data Science
  • CS Subjects
@GeeksforGeeks, Sanchhaya Education Private Limited, All rights reserved
We use cookies to ensure you have the best browsing experience on our website. By using our site, you acknowledge that you have read and understood our Cookie Policy & Privacy Policy
Lightbox
Improvement
Suggest Changes
Help us improve. Share your suggestions to enhance the article. Contribute your expertise and make a difference in the GeeksforGeeks portal.
geeksforgeeks-suggest-icon
Create Improvement
Enhance the article with your expertise. Contribute to the GeeksforGeeks community and help create better learning resources for all.
geeksforgeeks-improvement-icon
Suggest Changes
min 4 words, max Words Limit:1000

Thank You!

Your suggestions are valuable to us.

What kind of Experience do you want to share?

Interview Experiences
Admission Experiences
Career Journeys
Work Experiences
Campus Experiences
Competitive Exam Experiences